<div class="emoji-picker">
  <div class="header">
    <input type="text"
           class="search-bar"
           bind:value="tentativeQuery"
           placeholder={hovering || "Search for Emoji"} />
    <div class="diversity-button">
      <EmojiDiversityButton {color} {shape} />
    </div>
    <!-- Search and whatever -->
  </div>
  <div class="scroller" ref:scroller on:scroll|passive="onScroll(scrollTop, selectedCategory)">
    {#each categories as category, categoryIndex (category.name)}
    <EmojiCategory
      {scrollTop}
      {rowWidth}
      {clientHeight}
      name={category.name}
      {color}
      {shape}
      offset={calculateOffset(categoryIndex, categories, results, rowWidth)}
      items={calculateResults(results, category.items)}
      on:hover="set({hovering: event})"
      on:insert="fire('insert', event)" />
    {/each}
  </div>
  <div class="footer">
    {#each categories as category, categoryIndex (category.name)}
    <div class="category-button">
      <img
        on:click="refs.scroller.scrollTo({top: calculateOffset(categoryIndex, categories, results), behavior: 'smooth'})"
        class="category-icon"
        class:selected="selectedCategory == categoryIndex"
        alt={category.name}
        src={urlFor(categoryEmojis[category.name || category.items[0].n])} />
    </div>
    {/each}
  </div>
</div>

<script>
  import Fuse from "fuse.js";
  import {stems, categories} from "../js/emojis.js";
  import EmojiUtils from "../js/EmojiUtils";
  import {EMOJI_WIDTH, ROW_HEIGHT, NAME_HEIGHT} from "../js/EmojiPickerConstants";

  const fuse = new Fuse(stems, {
    shouldSort: true,
    threshold: 0.6,
    location: 0,
    distance: 100,
    maxPatternLength: 32,
    minMatchCharLength: 1,
    keys: ["n"]
  });

  window.emojiFuse = fuse;

  // {[categoryName]: [{n: "thinking", u: "https://..."}]}

  const _results = new Map();
  const _offsets = new Map();

  function calculateResults(results, emojis) {
    // console.log("EmojiPicker.calculateResults()");
    if (!results) return emojis;
    const cached = _results.get(emojis);
    if (cached) return cached;
    const items = emojis.filter(emoji => results.includes(emoji));
    _results.set(emojis, items);
    return items;
  }

  export default {
    components: {
      EmojiCategory: "./EmojiCategory.svelte",
      EmojiDiversityButton: "./EmojiDiversityButton.svelte"
    },
    computed: {
      rowWidth({$lastWidth}) {
        return $lastWidth > 700
          ? 10
          : Math.floor(($lastWidth - 16) / EMOJI_WIDTH);
      }
    },
    oncreate() {
      window.picker = this;
      this.set({
        clientHeight: this.refs.scroller.clientHeight
      });
    },
    data() {
      return {
        selectedCategory: 0,
        categories,
        categoryEmojis: {
          activities: "construction_worker_t1", // OMG THEY MADE JOSE EMOJI
          expressions: "headpats",
          "food drink herbs": "red_apple",
          gsr: "rainbow_flag",
          "nature effects": "rain",
          objects: "confetti_ball",
          "people animals": "deer_with_antlers",
          symbols: "100",
          "travel places": "mountain",
          utils: "paw_hand_modifier"
        },
        query: "",
        tentativeQuery: "",
        scrollTop: -100
      };
    },
    onstate({current, changed}) {
      if (changed.tentativeQuery) {
        // Throttle searching
        if (this._typingTimeout) clearTimeout(this._typingTimeout);
        if (current.tentativeQuery == "") {
          // console.log("Query..?");
          this.set({
            query: "",
            results: undefined
          });
        } else {
          this._typingTimeout = setTimeout(() => {
            this.set({
              query: current.tentativeQuery
            });
          }, 500);
        }
      }
      if (changed.query) {
        // console.log("Query changed!");
        _results.clear();
        this.set({
          results: current.query ? fuse.search(current.query) : undefined
        });
      }
    },
    ondestroy() {
      if (this._typingTimeout) clearTimeout(this._typingTimeout);
    },
    helpers: {
      urlFor: EmojiUtils.urlFor,
      calculateOffset(index, categories, results, rowWidth) {
        // const existing = _offsets.get(index);
        // if(existing != undefined) return existing;
        // console.time("EmojiPicker.calculateOffset()");
        const offset = categories
          .slice(0, index)
          .map(x => calculateResults(results, x.items))
          .map(x => ROW_HEIGHT * Math.ceil(x.length / rowWidth) + NAME_HEIGHT)
          .reduce((a, b) => a + b, 0);
        _offsets.set(index, offset);
        // console.log("ZZZ", offset, index);
        // console.timeEnd("EmojiPicker.calculateOffset()");
        // _offsets.set(index, offset);
        return offset;
      },
      calculateResults
    },
    methods: {
      // scrollTo() {},
      onScroll(scrollTop, selectedCategory) {
        // console.time("EmojiPicker.onScroll()");
        let diffed = false;
        const diff = {};
        const realScrollTop = this.refs.scroller.scrollTop;
        const newScrollTop = realScrollTop - 100;
        // We can pretty much get away with this with out extra buffer!

        let selectedIndex = null;
        for (const [categoryIndex, offset] of _offsets.entries()) {
          if (realScrollTop >= offset) selectedIndex = categoryIndex;
        }

        if (selectedIndex != selectedCategory) {
          diffed = true;
          diff.selectedCategory = selectedIndex;
        }

        if (Math.abs(newScrollTop - scrollTop) >= 50) {
          diffed = true;
          diff.scrollTop = newScrollTop;
        }

        if (diffed) this.set(diff);
        // console.timeEnd("EmojiPicker.onScroll()");
      }
    }
  };
</script>

<style>
  .emoji-picker {
    display: flex;
    flex-direction: column;
  }
  
  .scroller {
    padding: 0 8px;
    overflow: auto;
    flex-grow: 1;
    flex-shrink: 1;
  }

  .emoji-picker {
    height: 100%;
  }

  .header {
    height: 2.5em;
    flex-shrink: 0;
    flex-grow: 0;
    border-bottom: #2a2a2a solid 2px;
    display: flex;
  }

  .footer {
    height: 2.5em;
    flex-shrink: 0;
    flex-grow: 0;
    border-top: #2a2a2a solid 2px;
  }

  .search-bar {
    height: 2em;
    margin: 0.5em 0 0.5em 1em;
    border: none;
    border-radius: 1em;
    padding: 0 1em;
    flex-grow: 1;
    background: #222;
    color: #fff;
  }

  .diversity-button {
    display: inline-block;
    flex-grow: 0;
    flex-shrink: 0;
  }

  .search-bar:focus {
    outline: none;
  }

  .category-icon {
    height: 1.5em;
    width: 1.5em;
    padding: 0.125em;
    margin: 0.35em 0.125em;
    filter: grayscale(85%);
    border-radius: 3px;
  }

  .category-icon.selected,
  .category-icon:hover {
    filter: none;
    background: #4b4f52;
  }

  .footer {
    display: flex;
  }

  @media (max-width: 700px) {
    .footer {
      height: calc(2.5em + 4px);
      overflow-x: auto;
    }
  }

  .category-button {
    text-align: center;
    flex-grow: 1;
    flex-shrink: 1;
  }
</style>
